<template>
    <div id="talker">
        <ul>
            <h3 v-if="!selectedFriend">Select a person from the list or find the author of a post.      </h3>
            <li v-if="selectedFriend" v-for="(message, index) in messages" :key="index"
                :class="{ message: true, 'message-from': message.sender === selectedFriend }">
                <p class="message-header">Message {{ message.sender === selectedFriend?'from':'to'}} {{ selectedFriend }}</p>
                <div style="margin-left:5px" v-html="message.content" />
                <div class="message-footer">
                    <p>{{ message.sender }}</p>
                    <p>
                        {{ (new Date(message.created)).toLocaleDateString() }},
                        {{ (new Date(message.created)).toLocaleTimeString() }}
                    </p>
                </div>
            </li>
        </ul>
        <Input v-if="selectedFriend" @message="setMessage" @enter="send" :message="message" />
        <el-icon v-if="selectedFriend" @click="send" style="float: right; cursor: pointer;">
            <DArrowRight />
        </el-icon>
    </div>
</template>
  
<script setup lang="ts">
import { ref, Ref, onMounted, watch } from 'vue';
import { useRoute } from 'vue-router';

import useEmitter from '../composables/useEmitter';
import { useStore } from '../stores';

import { ElNotification } from 'element-plus';
import { DArrowRight } from "@element-plus/icons-vue";

import Message from '../interfaces/Message';

import Input from './Input.vue';

interface Props {
    selectedFriend: null | String
}

const emitter = useEmitter();
const emit = defineEmits(['sender'])
const store = useStore();
const route = useRoute();
const props = defineProps<Props>();

const messages: Ref<Message[]> = ref([]);
const message: Ref<String> = ref('');

store.setNotifyMessage(
    (data) => {
        const { sender, created, content } = data;
        console.log(route);
        if (route.name !== 'Communicator') {
            ElNotification({
                title: 'New message',
                message: `from ${sender}`,
                type: 'info',
                position: 'bottom-right'
            });
        }
        emit('sender', sender);
        messages.value.push({
            sender,
            created: new Date(created),
            content
        });
    });

onMounted(() => {
    const friends = Object.keys(store.messages);
    

    emitter.on('messages-loaded',()=>{
        friends.forEach(key => {
        messages.value.push({
            sender: key,
            created: new Date(store.messages[key].created),
            content: store.messages[key].content
        })
    })

    if (props.selectedFriend) {
        // @ts-ignore
        messages.value = store.messages[props.selectedFriend] || [];
    }
    })
    
});

watch(() => props.selectedFriend, (newValue, OldValue) => {
    if (newValue) {
        // @ts-ignore
        messages.value = store.messages[newValue];
    }
});

function send() {
    const content = message.value; //input.value.innerHTML;
    store.sendMessage(content, props.selectedFriend);
    message.value = '';
    messages.value.push({ sender: store.user.email, created: new Date(), content });
}

function setMessage(data) {
    message.value = data;
}


</script>
  
<style scoped lang="scss">
#talker {
    width: 50%;

    ul {
        padding: 0px;
        list-style-type: none;

        .message {
            // padding: 10px;
            box-shadow: inset -1px -1px 1px 0px rgba(16, 16, 16, 0.68);
            margin-top: 10px;
            border-radius: 5px;

            &.message-from {
                margin-left: 20px;
            }

            .message-header {
                display: flex;
                justify-content: space-evenly;
                background: #807436;
                color: lightcyan;
                border-top-right-radius: 5px;
                border-top-left-radius: 5px;
            }
            .message-footer {
                font-size: 10px;
                line-height: 10px;
                padding:7px;
                display: flex;
                flex-direction: row;
                justify-content: space-between;
            }

            &>div {
                overflow-wrap: break-word;
            }
        }
    }
}
</style>
  